//+------------------------------------------------------------------+
//|                                                         2HZZ.mq4 |
//|                                                           Candid |
//|                                         http://candid.110mb.com/ |
//+------------------------------------------------------------------+
#property copyright "Candid"
#property link      "http://candid.110mb.com/"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Tan
#property indicator_color2 Red
#property indicator_color3 Blue


extern int H = 35;
extern int MinBars = 0;
extern bool Arrows = 0;

double dH;
bool UpZ;
double CurMax,CurMin;
int CurMaxBar,CurMinBar;
double Top,Bot;
double SumR,SumT,SumTD;
int ZCnt;
int handle = -1;
string FileName;

int PreBars;
datetime BarTime;
int StartPos;
int pos;

double HZ_[], val1[], val2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   //if (SaveData) FileName = "HZZ.txt";
   IndicatorBuffers (3);
   SetIndexBuffer(0,HZ_);
	SetIndexBuffer (1, val1);
	SetIndexBuffer (2, val2);
   SetIndexStyle(0,DRAW_SECTION,EMPTY);
	SetIndexStyle (1, DRAW_ARROW);
	SetIndexStyle (2, DRAW_ARROW);
	SetIndexArrow (1, 234);
	SetIndexArrow (2, 233);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   if (!Arrows) {
    string s="CurMin"+H;
    ObjectCreate(s, OBJ_ARROW,0, Time[0], Low[0]);
    ObjectSet(s, OBJPROP_ARROWCODE, 159);
    ObjectSet(s, OBJPROP_COLOR, indicator_color2);
    s="CurMax"+H;
    ObjectCreate(s, OBJ_ARROW,0, Time[0], High[0]);
    ObjectSet(s, OBJPROP_ARROWCODE, 159);
    ObjectSet(s, OBJPROP_COLOR, indicator_color3);
   }
	/*if (MinBars < 0)
	{
	   bool TextFile = (MinBars < -1);
	   MinBars = 0;
		if (TextFile)
		{
			handle = FileOpen (Symbol() + Period() + "_" + H + ".asc", FILE_CSV | FILE_WRITE, '\t');
			FileWrite (handle, FilesNum, FileNum);
		}
		else
		{
			handle = FileOpen (Symbol() + Period() + "_" + H + ".asc", FILE_BIN | FILE_WRITE);
			FileWriteInteger (handle, FilesNum);
			FileWriteInteger (handle, FileNum);
		}
	}*/


  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
  ObjectDelete("CurMin"+H);
  ObjectDelete("CurMax"+H);
  //Comment("");
  //if (SaveData) FileClose(h);
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator reset function                                  |
//+------------------------------------------------------------------+
int Reset() {
  /*if (SaveData) {
    FileClose(h);
    h = FileOpen(FileName,FILE_CSV|FILE_WRITE,';');
  }*/
  if (MinBars==0) StartPos = Bars-1;
  else StartPos = MinBars;
  PreBars = 0;
  BarTime = 0;
  dH = H*Point;
  if (Digits % 2 == 1) dH *= 10;
  UpZ = true;
  CurMaxBar = 1;
  CurMinBar = 1;
  CurMax = High[StartPos];
  CurMin = Low[StartPos];
  Top = CurMin+dH;
  Bot = CurMax-dH;
  ZCnt = 0;
  SumR = 0.0;
  SumT = 0.0;
  SumTD = 0.0;
  StartPos++;
  return(StartPos);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
  if (Bars == PreBars) return(0);
  if (Bars < MinBars) {
    Comment(":    ");
    return(0);
  }  
  if (Bars-PreBars == 1 && BarTime==Time[1]) StartPos = 1;
  else StartPos = Reset();
  PreBars = Bars;  
  BarTime=Time[0];
  for (pos=StartPos;pos>0;pos--) {
    HZ_[pos] = 0;
    if (UpZ) {
      if (High[pos]>CurMax) {
        CurMax = High[pos];
        CurMaxBar = Bars-pos;
        Bot = CurMax-dH;
      } else {
        if (Low[pos]<Bot) {
          ZCnt++;
          if (ZCnt > 3) {
            SumR += CurMax-CurMin;
            SumT += CurMaxBar-CurMinBar;
            SumTD += Bars-pos-CurMaxBar;            
            /*string sTime=TimeToStr(Time[Bars-CurMaxBar],TIME_DATE|TIME_MINUTES);
            if (SaveData) FileWrite(h,sTime,NormalizeDouble(CurMax,Digits));*/
          }
          UpZ = false;
          HZ_[Bars-CurMaxBar]=CurMax;
          if (Arrows) val1[pos] = CurMax;
          else {
            string s="CurMax"+H;
            ObjectSet(s, OBJPROP_TIME1, Time[pos]);
            ObjectSet(s, OBJPROP_PRICE1, CurMax);
          }
          CurMinBar = Bars-pos;
          CurMin = Low[pos];
          Top = CurMin+dH;
        }
      }
    }  else {
      if (Low[pos]<CurMin) {
        CurMinBar = Bars-pos;
        CurMin = Low[pos];
        Top = CurMin+dH;
      } else {
        if (High[pos]>Top) {
          ZCnt++;
          if (ZCnt > 3) {
            SumR += CurMax-CurMin;
            SumT += CurMinBar-CurMaxBar;
            SumTD += Bars-pos-CurMinBar;
            /*sTime=TimeToStr(Time[Bars-CurMinBar],TIME_DATE|TIME_MINUTES);
            if (SaveData) FileWrite(h,sTime,NormalizeDouble(CurMin,Digits));*/
          }
          UpZ = true;
          HZ_[Bars-CurMinBar]=CurMin;
          if (Arrows) val2[pos] = CurMin;
          else {
            s="CurMin"+H;
            ObjectSet(s, OBJPROP_TIME1, Time[pos]);
            ObjectSet(s, OBJPROP_PRICE1, CurMin);
          }
          CurMaxBar = Bars-pos;
          CurMax = High[pos];
          Bot = CurMax-dH;
        }
      }
    }
  }  //  pos=StartPos;pos>0;pos--) 
  if (ZCnt > 3) {
    int NZ = ZCnt-3;
    double rz = SumR/NZ;
    Comment(" : ",rz,",  : ",SumT/NZ,",  : ",SumTD/NZ,", oef: ",rz/dH);  
  }
  return(0);
}
//+------------------------------------------------------------------+